Index: orxonox/branches/physics/src/world_entities/player.h
===================================================================
--- orxonox/branches/physics/src/world_entities/player.h	(revision 3866)
+++ orxonox/branches/physics/src/world_entities/player.h	(revision 3953)
@@ -11,4 +11,5 @@
 template<class T> class tList;
 class Weapon;
+class WeaponManager;
 class Vector;
 class World;
@@ -49,4 +50,5 @@
   Weapon* activeWeapon;  //!< the weapon that is currenty activated
   Weapon* activeWeaponL;  //temporary -- FIX THIS
+  WeaponManager* weaponMan; //!< the weapon manager: managing a list of weapon to wepaon-slot mapping
 
   World* myWorld;        //!< reference to the world object
Index: orxonox/branches/physics/src/world_entities/skybox.cc
===================================================================
--- orxonox/branches/physics/src/world_entities/skybox.cc	(revision 3866)
+++ orxonox/branches/physics/src/world_entities/skybox.cc	(revision 3953)
@@ -187,16 +187,16 @@
   model->addVertexNormal (-1.0, 0.0, 0.0);
 
-  model->addUseMtl(material[0]);
-  model->addFace (4, 3, 3,2,4, 4,3,4, 6,4,4, 5,1,4); // top
-  model->addUseMtl(material[1]);
-  model->addFace (4, 3, 7,4,2, 8,1,2, 2,2,2, 1,3,2); // bottom
-  model->addUseMtl(material[2]);
-  model->addFace (4, 3, 1,1,3, 2,2,3, 4,3,3, 3,4,3); // left
-  model->addUseMtl(material[3]);
-  model->addFace (4, 3, 5,3,1, 6,4,1, 8,1,1, 7,2,1); // right
-  model->addUseMtl(material[4]);
-  model->addFace (4, 3, 2,1,6, 8,2,6, 6,3,6, 4,4,6); // front
-  model->addUseMtl(material[5]);
-  model->addFace (4, 3, 7,1,5, 1,2,5, 3,3,5, 5,4,5); // back
+  model->setMaterial(material[0]);
+  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 3,2,4, 4,3,4, 6,4,4, 5,1,4); // top
+  model->setMaterial(material[1]);
+  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 7,4,2, 8,1,2, 2,2,2, 1,3,2); // bottom
+  model->setMaterial(material[2]);
+  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 1,1,3, 2,2,3, 4,3,3, 3,4,3); // left
+  model->setMaterial(material[3]);
+  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 5,3,1, 6,4,1, 8,1,1, 7,2,1); // right
+  model->setMaterial(material[4]);
+  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 2,1,6, 8,2,6, 6,3,6, 4,4,6); // front
+  model->setMaterial(material[5]);
+  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 7,1,5, 1,2,5, 3,3,5, 5,4,5); // back
   
   model->finalize();
Index: orxonox/branches/physics/src/world_entities/test_gun.cc
===================================================================
--- orxonox/branches/physics/src/world_entities/test_gun.cc	(revision 3866)
+++ orxonox/branches/physics/src/world_entities/test_gun.cc	(revision 3953)
@@ -40,5 +40,5 @@
    creates a new weapon
 */
-TestGun::TestGun (PNode* parent, Vector* coordinate, Quaternion* direction, int leftRight) 
+TestGun::TestGun (PNode* parent, const Vector& coordinate, const Quaternion& direction, int leftRight) 
   :  Weapon (parent, coordinate, direction) 
 {
@@ -47,43 +47,26 @@
   this->leftRight = leftRight;
 
-  if( this->leftRight == 0)
-    this->projOffset = new Vector(1.0, 0.0, -0.35);
-  else if( this->leftRight == 1)
-    this->projOffset = new Vector(1.0, 0.0, 0.5);
+  this->objectComponent1 = new PNode();
+  this->animation1 = new Animation3D(this->objectComponent1);
+  parent->addChild(this->objectComponent1, PNODE_ALL);
 
+  this->animation1->setInfinity(ANIM_INF_CONSTANT);
+  // ANIM_LINEAR was ANIM_NEG_EXP
+  if( this->leftRight == W_LEFT)
+    {
+      this->projectileOffset = Vector(1.0, 0.0, -0.35);
 
-  this->dummy1 = new WorldEntity(); // a world entity that is not drawed: use this for the weapon 
-  this->animation = new Animation3D(dummy1);
+      this->animation1->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.1, ANIM_LINEAR); 
+      this->animation1->addKeyFrame(Vector(-3.0, 0.1, 3.0), Quaternion(), 0.5, ANIM_LINEAR);
+      this->animation1->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.1, ANIM_LINEAR);
+    }
+  else if( this->leftRight == W_RIGHT)
+    {
+      this->projectileOffset = Vector(1.0, 0.0, 0.5);
 
-  parent->addChild(this->dummy1, PNODE_ALL);
-
-  this->animation->setInfinity(ANIM_INF_CONSTANT);
-  // ANIM_LINEAR was ANIM_NEG_EXP
-  if( this->leftRight == 0)
-    {
-      this->animation->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.1, ANIM_LINEAR); 
-      this->animation->addKeyFrame(Vector(-3.0, 0.1, 3.0), Quaternion(), 0.5, ANIM_LINEAR);
-      this->animation->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.1, ANIM_LINEAR);
+      this->animation1->addKeyFrame(Vector(-2.6, 0.1, -2.5), Quaternion(), 0.1, ANIM_LINEAR);
+      this->animation1->addKeyFrame(Vector(-3.0, 0.1, -2.5), Quaternion(), 0.5, ANIM_LINEAR);
+      this->animation1->addKeyFrame(Vector(-2.6, 0.1, -2.5), Quaternion(), 0.1, ANIM_LINEAR);
     }
-  else if( this->leftRight == 1)
-    {
-      this->animation->addKeyFrame(Vector(-2.6, 0.1, -2.5), Quaternion(), 0.1, ANIM_LINEAR);
-      this->animation->addKeyFrame(Vector(-3.0, 0.1, -2.5), Quaternion(), 0.5, ANIM_LINEAR);
-      this->animation->addKeyFrame(Vector(-2.6, 0.1, -2.5), Quaternion(), 0.1, ANIM_LINEAR);
-    }
-  /*
-  if( this->leftRight == 0)
-    {
-      this->animation->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.0, ANIM_NEG_EXP); 
-      this->animation->addKeyFrame(Vector(-3.0, 0.1, 3.0), Quaternion(), 0.1, ANIM_NEG_EXP);
-      this->animation->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.5, ANIM_NEG_EXP);
-    }
-  else if( this->leftRight == 1)
-    {
-      this->animation->addKeyFrame(Vector(-2.6, 0.1, -2.5), Quaternion(), 0.0, ANIM_NEG_EXP);
-      this->animation->addKeyFrame(Vector(-3.0, 0.1, -2.5), Quaternion(), 0.1, ANIM_NEG_EXP);
-      this->animation->addKeyFrame(Vector(-2.6, 0.1, -2.5), Quaternion(), 0.5, ANIM_NEG_EXP);
-    }
-  */
 }
 
@@ -127,21 +110,19 @@
 void TestGun::fire()
 {
-  if( this->localTime < this->idleTime)
+  if( !this->hasWeaponIdleTimeElapsed())
     {
       this->weaponIdle();
       return;
     }
+
   Projectile* pj = new TestBullet(this);
-
-  pj->setAbsCoor(this->getAbsCoor() + *this->projOffset);
+  pj->setAbsCoor(this->getAbsCoor() + this->projectileOffset);
   pj->setAbsDir(this->getAbsDir());
-
   pj->setFlightDirection(this->getAbsDir());
   pj->setSpeed(this->getSpeed());
-
   this->worldEntities->add(pj);
   this->localTime = 0;
   
-  this->animation->replay();
+  this->animation1->replay();
 }
 
@@ -190,44 +171,25 @@
 void TestGun::draw () 
 {
-  
-  /* draw gun body 1 */
+  /* draw gun body */
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
   float matrix[4][4];
-  
-  if( this->leftRight == 0)
-    {
-      glTranslatef (this->getAbsCoor ().x, 
-		    this->getAbsCoor ().y, 
-		    this->getAbsCoor ().z);
-      
-      this->getAbsDir ().matrix (matrix);
-      glMultMatrixf((float*)matrix);
-      this->model->draw(1);
-    }
-  else if( this->leftRight == 1)
-    {
-      glTranslatef (this->getAbsCoor ().x, 
-		    this->getAbsCoor ().y, 
-		    this->getAbsCoor ().z);
-      
-      this->getAbsDir ().matrix (matrix);
-      glMultMatrixf((float*)matrix);
-      glScalef(1.0, 1.0, -1.0);
-      this->model->draw(1);
-    }
-
+  glTranslatef (this->getAbsCoor ().x, 
+		this->getAbsCoor ().y, 
+		this->getAbsCoor ().z);  
+  this->getAbsDir ().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+  if( this->leftRight == W_RIGHT)
+    glScalef(1.0, 1.0, -1.0);
+  this->model->draw(1);
   glPopMatrix();
 
-
-  /* draw gun coil 1 */
+  /* draw objectComponent1: gun coil - animated stuff */
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
-  
-  glTranslatef (this->dummy1->getAbsCoor ().x, 
-		this->dummy1->getAbsCoor ().y, 
-		this->dummy1->getAbsCoor ().z);
-
-  this->dummy1->getAbsDir ().matrix (matrix);
+  glTranslatef (this->objectComponent1->getAbsCoor ().x, 
+		this->objectComponent1->getAbsCoor ().y, 
+		this->objectComponent1->getAbsCoor ().z);
+  this->objectComponent1->getAbsDir ().matrix (matrix);
   glMultMatrixf((float*)matrix);
   this->model->draw(0);
Index: orxonox/branches/physics/src/world_entities/test_gun.h
===================================================================
--- orxonox/branches/physics/src/world_entities/test_gun.h	(revision 3866)
+++ orxonox/branches/physics/src/world_entities/test_gun.h	(revision 3953)
@@ -37,5 +37,5 @@
 
  public:
-  TestGun (PNode* parent, Vector* coordinate, Quaternion* direction, int leftRight);
+  TestGun (PNode* parent, const Vector& coordinate, const Quaternion& direction, int leftRight);
   virtual ~TestGun ();
 
@@ -51,9 +51,6 @@
   virtual void draw(void);
 
- private:
-  Animation3D* animation;
-  Vector* projOffset;
-  WorldEntity* dummy1;
-  int leftRight;   // this will become an enum
+
+
 
 };
Index: orxonox/branches/physics/src/world_entities/weapon.cc
===================================================================
--- orxonox/branches/physics/src/world_entities/weapon.cc	(revision 3866)
+++ orxonox/branches/physics/src/world_entities/weapon.cc	(revision 3953)
@@ -16,4 +16,5 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
 
 #include "weapon.h"
@@ -30,44 +31,165 @@
 
 
+/**
+   \brief this initializes the weaponManager for a given nnumber of weapon slots
+   \param number of weapon slots of the model/ship <= 8 (limitied)
+*/
 WeaponManager::WeaponManager(int nrOfSlots) 
 {
+  for(int i = 0; i < W_MAX_CONFIGS; ++i)
+    {
+      this->configs[i].bUsed = false;
+      for(int j = 0; j < W_MAX_SLOTS; ++j)
+	this->configs[i].slots[j] = NULL;
+    }
   this->nrOfSlots = nrOfSlots;
-  this->nrOfConfigs = 1;
-
-  for(int i = 0; i < W_MAX_CONFS; ++i)
-    this->configs[i] = NULL;
-  this->currentConfig = new weaponConfig;
-  this->configs[0] = this->currentConfig;
-}
+  this->currConfID = W_CONFIG0;
+}
+
 
 WeaponManager::~WeaponManager() 
 {
-
-}
-
-void WeaponManager::addWeapon(Weapon* weapon, slotID slot, configID config) 
-{
-  if(this->configs[config] == NULL)
-    PRINTF(0)("");
-  //  this->configs[(int)config]->
-}
-
-void WeaponManager::addWeaponConfig(weaponConfig* config) 
-{}
-
+  /* 
+     i dont have to delete the weapons itself, because they are 
+     worldentities and therefore in the entities list of the world.
+     world will clean them up for me
+  */
+  for(int i = 0; i < W_MAX_CONFIGS; ++i)
+    {
+      this->configs[i].bUsed = false;
+      for(int j = 0; j < W_MAX_SLOTS; ++j)
+	this->configs[i].slots[j] = NULL;
+    }
+}
+
+
+/**
+   \brief adds a weapon to the selected weaponconfiguration into the selected slot
+   \param the weapon to add
+   \param an identifier for the slot: number between 0..7 if not specified: slotID=next free slot
+   \param an identifier for the weapon configuration, number between 0..3
+
+   if you add explicitly a weapon at config:n, slot:m, the weapon placed at this location will be
+   replaced by the weapon specified. if you use the W_FREE_SLOT, the manager will look for a free
+   slot in this weaponconfiguration. if there is non, the weapon won't be added and there will be 
+   a error message.
+*/
+void WeaponManager::addWeapon(Weapon* weapon, int configID, int slotID) 
+{
+  if( slotID == W_FREE_SLOT)
+    {
+      int freeSlot = this->getNextFreeSlot( configID);
+      if( freeSlot < 0 || freeSlot >= this->nrOfSlots)
+	{
+	  PRINTF(0)("There is no free slot in this WeaponConfig to dock this weapon at! Aborting\n");
+	  return;
+	}
+      PRINTF(3)("Added new Weapon to Config:%i/Slot:%i\n", configID, freeSlot);
+      this->configs[configID].bUsed = true;
+      this->configs[configID].slots[freeSlot] = weapon;
+      return;
+    }
+  this->configs[configID].bUsed = true;
+  this->configs[configID].slots[slotID] = weapon;
+  PRINTF(3)("Added a new Weapon to the WeaponManager: config %i/ slot %i\n", configID, slotID);
+}
+
+
+void WeaponManager::removeWeapon(Weapon* weapon, int configID)
+{
+  /* empty */
+}
+
+
+/**
+   \brief changes to the next weapon configuration
+
+   if there are multiple weapon configurations defined by the manager, use this to switch between them
+   this function will deactivate the weapons first, change the config and reactivate them later
+*/
 void WeaponManager::nextWeaponConf() 
-{}
-
-void WeaponManager::prevWeaponConf() 
-{}
-
-
-void WeaponManager::selectConfig(configID config) 
-{
-  if( this->configs[(int)config] != NULL)
-    this->currentConfig = this->configs[(int)config];
-  else
-    PRINTF(0)("There is no weapon config defined with the number W_CONF%i", (int)config);
-}
+{
+  PRINTF(4)("Changing weapon configuration: from %i\n", this->currConfID);
+
+  Weapon* w;
+  for(int i = 0; i < W_MAX_SLOTS; ++i)
+    {
+      w = this->configs[this->currConfID].slots[i];
+      if( w != NULL) w->deactivate();
+    }
+  int i;
+  for(i = this->currConfID + 1; i < W_MAX_CONFIGS && !this->configs[i].bUsed; ++i);
+  if( i == W_MAX_CONFIGS) this->currConfID = W_CONFIG0;
+  else this->currConfID = i;  
+  PRINTF(4)("\tto %i\n", this->currConfID);
+
+  for(int i = 0; i < W_MAX_SLOTS; ++i)
+    {
+      w = this->configs[this->currConfID].slots[i];
+      if( w != NULL) w->activate();
+    }
+}
+
+
+
+/**
+   \brief triggers fire of all weapons in the current weaponconfig
+*/
+void WeaponManager::fire()
+{
+  Weapon* firingWeapon;
+  for(int i = 0; i < W_MAX_SLOTS; ++i)
+    {
+      firingWeapon = this->configs[this->currConfID].slots[i];
+      if( firingWeapon != NULL) firingWeapon->fire();
+    }
+}
+
+
+/**
+   \brief triggers tick of all weapons in the current weaponconfig
+   \param second passed since last tick
+*/
+void WeaponManager::tick(float sec)
+{
+  Weapon* w;
+  for(int i = 0; i < W_MAX_SLOTS; ++i)
+    {
+      w = this->configs[this->currConfID].slots[i];
+      if( w != NULL) w->tick(sec);
+    }
+}
+
+
+/**
+   \brief triggers draw of all weapons in the current weaponconfig
+*/
+void WeaponManager::draw()
+{
+  Weapon* w;
+  for(int i = 0; i < W_MAX_SLOTS; ++i)
+    {
+      w = this->configs[this->currConfID].slots[i];
+      if( w != NULL) w->draw();
+    }
+}
+
+
+/**
+   \brief private gets the next free slot in a certain weaponconfig
+   \param the selected weaponconfig
+*/
+int WeaponManager::getNextFreeSlot(int configID)
+{
+  for( int i = 0; i < W_MAX_SLOTS; ++i)
+    {
+      if( this->configs[configID].slots[i] == NULL)
+	return i;
+    }
+  return -1;
+}
+
+
+
 
 
@@ -78,12 +200,20 @@
    creates a new weapon
 */
-Weapon::Weapon (PNode* parent, Vector* coordinate, Quaternion* direction) 
+Weapon::Weapon (PNode* parent, const Vector& coordinate, const Quaternion& direction) 
   : WorldEntity()
 {
   parent->addChild(this, PNODE_ALL);
-  this->setRelCoor(*coordinate);
-  this->setRelDir(*direction);
+  this->setRelCoor(coordinate);
+  this->setRelDir(direction);
   WorldInterface* wi = WorldInterface::getInstance();
   this->worldEntities = wi->getEntityList();
+
+  this->objectComponent1 = NULL;
+  this->objectComponent2 = NULL;
+  this->objectComponent3 = NULL;
+
+  this->animation1 = NULL;
+  this->animation2 = NULL;
+  this->animation3 = NULL;
 }
 
@@ -95,4 +225,9 @@
 {
   // model will be deleted from WorldEntity-destructor
+  //this->worldEntities = NULL;
+  
+  /* dont delete objectComponentsX here, they will be killed when the pnodes are cleaned out */
+
+  /* all animations are deleted via the animation player*/
 }
 
@@ -190,48 +325,7 @@
 {}
 
-/**
-   \brief sets a weapon idle time
-   \param idle time in ms
-
-   a weapon idle time is the time spend after a shoot until the weapon can
-   shoot again
-*/
-void Weapon::setWeaponIdleTime(float time)
-{
-  this->idleTime = time;
-}
-
-/**
-   \brief gets the weapon idle time
-   \returns idle time in ms
-
-   a weapon idle time is the time spend after a shoot until the weapon can
-   shoot again
-*/
-float Weapon::getWeaponIdleTime(void)
-{
-  return this->idleTime;
-}
-
-/**
-   \brief checks if the idle time is elapsed
-   \return true if time is elapsed
-
-   a weapon idle time is the time spend after a shoot until the weapon can
-   shoot again
-*/
-bool Weapon::hasWeaponIdleTimeElapsed(void)
-{
-  return (this->localTime>this->idleTime)?true:false;
-}
-
-
-/**
-   \brief fires the weapon
-   
-   this is called from the player.cc, when fire-button is been pushed
-*/
-void Weapon::fire()
-{}
+
+
+
 
 
Index: orxonox/branches/physics/src/world_entities/weapon.h
===================================================================
--- orxonox/branches/physics/src/world_entities/weapon.h	(revision 3866)
+++ orxonox/branches/physics/src/world_entities/weapon.h	(revision 3953)
@@ -34,8 +34,9 @@
 
 #define W_MAX_SLOTS 8
-#define W_MAX_CONFS 4
+#define W_MAX_CONFIGS 4
 
 class Projectile;
 class Weapon;
+class Animation3D;
 
 typedef enum {
@@ -48,22 +49,31 @@
 } weaponSoundType;
 
+
 //! this is an identifier for the slot. there are up to 8 weapon slots -> this means there can't be more than 8 weapons at the same time
-typedef enum slotID {W_SLOT0=0, W_SLOT1, W_SLOT2, W_SLOT3, 
-		     W_SLOT4, W_SLOT5, W_SLOT6, W_SLOT7};
+#define W_SLOT0 0
+#define W_SLOT1 1
+#define W_SLOT2 2
+#define W_SLOT3 3
+#define W_SLOT4 4
+#define W_SLOT5 5
+#define W_SLOT6 6
+#define W_SLOT7 7
+#define W_FREE_SLOT 99
+
 
 //! this is an identifier for the weapon config
-typedef enum configID {W_CONFIG0=0, W_CONFIG1, 
-		       W_CONFIG2, W_CONFIG3};
+#define W_CONFIG0 0
+#define W_CONFIG1 1
+#define W_CONFIG2 2
+#define W_CONFIG3 3
+
+//! a weapon can be left or right sided
+#define W_LEFT 0
+#define W_RIGHT 1
 
 //! this is a weapon Configuration: it has up to 8 slots
 typedef struct weaponConfig {
-  Weapon* slot1;                    //<! standard right side weapon
-  Weapon* slot2;                    //<! standard left side weapon
-  Weapon* slot3;                    //<! custom
-  Weapon* slot4;                    //<! custom
-  Weapon* slot5;                    //<! custom
-  Weapon* slot6;                    //<! custom
-  Weapon* slot7;                    //<! custom
-  Weapon* slot8;                    //<! custom
+  bool bUsed;                       //<! is set to true, if this configuration is 
+  Weapon* slots[8];
 };
 
@@ -74,16 +84,18 @@
   ~WeaponManager();
   
-  void addWeapon(Weapon* weapon, slotID slot, configID config = W_CONFIG0);
-  void addWeaponConfig(weaponConfig* config);
+  void addWeapon(Weapon* weapon, int configID = W_CONFIG0, int slotID = W_FREE_SLOT);
+  void removeWeapon(Weapon* weapon, int configID = W_CONFIG0);
+  void nextWeaponConf();
 
-  void nextWeaponConf();
-  void prevWeaponConf();
-  void selectConfig(configID config);
+  void fire();
+  void tick(float sec);
+  void draw();
 
  private:
-  int nrOfConfigs;                      //<! number of configurations defined
   int nrOfSlots;                        //<! number of weapon slots a ship has
-  weaponConfig* currentConfig;          //<! the currently selected config
-  weaponConfig* configs[4];             //<! a list of four configurations
+  int currConfID;                       //<! the currently selected config
+  weaponConfig configs[4];              //<! a list of four configurations
+  
+  int getNextFreeSlot(int configID);
 };
 
@@ -93,5 +105,5 @@
 
  public:
-  Weapon (PNode* parent, Vector* coordinate, Quaternion* direction);
+  Weapon (PNode* parent, const Vector& coordinate, const Quaternion& direction);
   virtual ~Weapon ();
   
@@ -107,8 +119,35 @@
   bool isActive(void);
 
-  void setWeaponIdleTime(float time);
-  float getWeaponIdleTime(void);
-  bool hasWeaponIdleTimeElapsed(void);
 
+  /**
+     \brief sets a weapon idle time
+     \param idle time in ms
+     
+     a weapon idle time is the time spend after a shoot until the weapon can
+     shoot again
+  */
+  inline void setWeaponIdleTime(float time) { this->idleTime = time; }
+  /**
+     \brief gets the weapon idle time
+     \returns idle time in ms
+     
+     a weapon idle time is the time spend after a shoot until the weapon can
+     shoot again
+  */
+  inline float getWeaponIdleTime(void) const { return this->idleTime;}
+  /**
+     \brief checks if the idle time is elapsed
+     \return true if time is elapsed
+     
+     a weapon idle time is the time spend after a shoot until the weapon can
+   shoot again
+  */
+  inline bool hasWeaponIdleTimeElapsed(void) const { return (this->localTime>this->idleTime)?true:false; }
+
+  /**
+     \brief fires the weapon
+     
+     this is called from the player.cc, when fire-button is been pushed
+  */
   virtual void fire(void) = 0;
   virtual void hit (WorldEntity* weapon, Vector* loc);
@@ -121,11 +160,22 @@
  protected:
   tList<WorldEntity>* worldEntities;
-  float localTime;
-  float idleTime;
-  float slowDownFactor;
+  float localTime;                 //<! this is the local time. important for shooting attributes like frequency
+  float idleTime;                  //<! the time a weapon needs before it can shoot again. eg. shooting frequency or actication/deactivateion delay
+  float slowDownFactor;            //<! if the shooting frequency is a linear function of time...
+
+  PNode* objectComponent1;         //<! the gun is made of multiple parts, these PNodes represent their location and orientation
+  PNode* objectComponent2;
+  PNode* objectComponent3;
+
+  Animation3D* animation1;
+  Animation3D* animation2;
+  Animation3D* animation3;
+
+  Vector projectileOffset;
+  int leftRight;   // this will become an enum
 
  private:
-  bool enabled;
-  Projectile* projectile;
+  bool enabled;                    //<! states if the weapon is enabled or not
+  Projectile* projectile;          //<! the projectile used for this weapon
   //WeaponSound sound;
 };
